#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<cmath>
#include<iostream>
#include<fstream>
#include<algorithm>
#define MOD 19491001LL
using namespace std;
ifstream fin ("Fibonacci.in");
ofstream fout ("Fibonacci.out");
struct RECT{
	long long r[2][2];
}a,b;
RECT operator * (RECT u,RECT v){
	RECT w;
	w.r[0][0]=((u.r[0][0]*v.r[0][0])%MOD+(u.r[0][1]*v.r[1][0])%MOD)%MOD;
	w.r[0][1]=((u.r[0][0]*v.r[0][1])%MOD+(u.r[0][1]*v.r[1][1])%MOD)%MOD;
	w.r[1][0]=((u.r[1][0]*v.r[0][0])%MOD+(u.r[1][1]*v.r[1][0])%MOD)%MOD;
	w.r[1][1]=((u.r[1][0]*v.r[0][1])%MOD+(u.r[1][1]*v.r[1][1])%MOD)%MOD;
	return w;
}
RECT POW (long n){
	if (n==1) return b;
	RECT u=POW(n>>1);
	u=u*u;
	if (n&1) u=u*b;
	return u;
}
long gcd (long u,long v){
	return v==0?u:gcd(v,u%v);
}
int main(){
	long i,j,k,m,n,u,v;
	fin >> n;
	b.r[0][0]=b.r[0][1]=b.r[1][0]=1LL;
	for (i=1;i<=n;++i){
		fin >> u >> v;
		k=gcd(u,v);
		if (k==1) fout << 1 << endl;
		else{
			a=POW(k-1);
			fout << a.r[0][0] << endl;
		}
	}
	fin.close();
	fout.close();
	return 0;
}

