#include <cstdio>
#include <cstring>
#include <algorithm>

const int maxn = 1000 + 50;
const int mod = 1000;
const int inf = 0x3f3f3f3f >> 1;
int n;
int val[maxn];
int last[maxn], pre[maxn * maxn], other[maxn * maxn], key[maxn * maxn];
int num[maxn][20];
int er[5][5];
int ter = 0;
int tot = 0;
int dis[maxn];
static int que[maxn];
static bool flag[maxn];

void spfa(int x) {
	for (int i = 1; i <= n; i++) dis[i] = inf;
	dis[1] = 0;
	int h = 0, t = 1;
	que[1] = 1;
	while (h < t) {
		h = (h + 1) % mod;
		int cur = que[h];
		flag[cur] = 0;
		for (int p = last[cur]; p; p = pre[p]) {
			int q = other[p];
			if (dis[q] > dis[cur] + key[p]) {
				dis[q] = dis[cur] + key[p];
				if (flag[q] == 0) {
					flag[q] = 1;
					t = (t + 1) % mod;
					que[t] = q;
				}
			}
		}
	}
}

void add(int x, int y, int z) {
	tot++;
	pre[tot] = last[x];
	last[x] = tot;
	other[tot] = y;
	key[tot] = z;
}

int main () {
	freopen("math.in", "r", stdin);
	freopen("math.out", "w", stdout);
	scanf("%d", &n);
	for (int i = 1; i <= 10; i++) scanf("%d", &val[i]);
	for (int i = 1; i <= n; i++) 
		for (int j = 1; j <= 10; j++) scanf("%1d", &num[i][j]);
	//for (int i = 1; i <= n; i++) {
	//	for (int j = 1; j <= 10; j++) printf("%d ", num[i][j]);
	//	printf("\n");
	//}
	for (int i = 1; i <= n; i++)
		for (int j = 1; j < i; j++) {
			int cur = 0;
			memset(er, 0, sizeof(er));
			ter = 0;
			for (int k = 1; k <= 10; k++) 
				if (num[i][k] == num[j][k]) cur++;
				else break;
			for (int k = 1; k <= 10; k++) {
				if (num[i][k] != num[j][k]) {
 					ter++;
					er[ter][1] = num[i][k];
					er[ter][2] = num[j][k];
				}
			}
			if (ter <= 1) {
				add(i, j, val[cur+1]);
				add(j, i, val[cur+1]);
			} else if (ter == 2) {
				if (er[1][1] != er[2][2]) continue;
				if (er[2][1] != er[1][2]) continue;
				add(i, j, val[cur+1]);
				add(j, i, val[cur+1]);
			}
		}
	spfa(1);
	if (dis[n] == inf) printf("-1");
	else printf("%d", dis[n]);
	return 0;
}
