/*
PROG: C++
TASK: Fibonacci
*/

#include <ctime>
#include <cmath>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>
#include <queue>

using namespace std ;

FILE *fi , *fo ;

#define mod 19491001LL

long long T , A , B , G ;
long long f[3] , c[3][3] ;
long long gcd(long long x,long long y){for(long long z;y;z=x%=y,x=y,y=z);return x;}


long long e[3][3] , t[3][3] ;
void ksm ( long long top )
{
	memset(e,0,sizeof(e)) , memcpy(e,c,sizeof(c)) , top-- ;
	while ( top )
	{
		if(top&1)
		{
			memset(t,0,sizeof(t)) ;
			t[1][1]=(c[1][1]*e[1][1]+c[1][2]*e[2][1])%mod ;
			t[1][2]=(c[1][1]*e[1][2]+c[1][2]*e[2][2])%mod ;
			t[2][1]=(c[2][1]*e[1][1]+c[2][2]*e[2][1])%mod ;
			t[2][2]=(c[2][1]*e[1][2]+c[2][2]*e[2][2])%mod ;
			memcpy(c,t,sizeof(t)) ;
		}
		memset(t,0,sizeof(t)) ;
		t[1][1]=(e[1][1]*e[1][1]+e[1][2]*e[2][1])%mod ;
		t[1][2]=(e[1][1]*e[1][2]+e[1][2]*e[2][2])%mod ;
		t[2][1]=(e[2][1]*e[1][1]+e[2][2]*e[2][1])%mod ;
		t[2][2]=(e[2][1]*e[1][2]+e[2][2]*e[2][2])%mod ;
		memcpy(e,t,sizeof(t)) ;
		top>>=1 ;
	}
}
long long tmp[3] ;
void pl()
{
	memset(tmp,0,sizeof(tmp)) ;
	tmp[1]=(f[1]*c[1][1]+f[2]*c[2][1])%mod ;
	tmp[2]=(f[1]*c[1][2]+f[2]*c[2][2])%mod ;
	memcpy(f,tmp,sizeof(tmp)) ;
	return ;
}

int main()
{
	fi = fopen ( "Fibonacci.in" , "r" ) ;
	fo = fopen ( "Fibonacci.out" , "w" ) ;
	
	long long i ;
	fscanf ( fi , "%I64d" , &T ) ;
	while ( T-- )
	{
		memset(f,0,sizeof(f)) , memset(c,0,sizeof(c)) ;
		f[1]=f[2]=1 ; c[1][2]=c[2][1]=c[2][2]=1 ;
		fscanf ( fi , "%I64d%I64d" , &A , &B ) , G=gcd(A,B) ;
		// target = Fibonacci[gcd(A,B)] ;
		// printf ( "%I64d\n" , G ) ; getchar() ;
		if ( G<=2 ) fprintf ( fo , "1\n" ) ;
		else ksm(G-2) , pl() , fprintf ( fo , "%I64d\n" , f[2] ) ;
	}
	
	
	fclose ( fi ) ;
	fclose ( fo ) ;
	return 0 ;
}
