#include <stdio.h>
#include <stdlib.h>
#define mod 19491001

long long f[10];
long long t[4][4],z[4][4];
long long matrix[4][4];
long long i,j,k,n,x,y;

long long gcd(long long a,long long b)
{
	if (a%b==0)
		return b;

	return gcd(b,a%b);
}

void work(long long y)
{
	long long i,j,k;

	if (y==0)
		return;

	work(y>>1);
	for (i=1; i<=3; i++)
		for (j=1; j<=3; j++)
			for (k=1; k<=3; k++)
				t[i][k]=(t[i][k]+z[i][j]*z[j][k])%mod;

	for (i=1; i<=3; i++)
		for (j=1; j<=3; j++)
		{
			z[i][j]=t[i][j];
			t[i][j]=0;
		}

	if (y%2==0)
		return;

	for (i=1; i<=3; i++)
		for (j=1; j<=3; j++)
			for (k=1; k<=3; k++)
				t[i][k]=(t[i][k]+z[j][k]*matrix[i][j])%mod;

	for (i=1; i<=3; i++)
		for (j=1; j<=3; j++)
		{
			z[i][j]=t[i][j];
			t[i][j]=0;
		}
}

int main()
{
	freopen("Fibonacci.in","r",stdin);
	freopen("Fibonacci.out","w",stdout);
	scanf("%I64d",&n);
	f[1]=1;
	f[2]=1;
	f[3]=2;
	while (n>0)
	{
		n--;
		scanf("%I64d%I64d",&x,&y);
		x=gcd(x,y);
		if (x<=3)
		{
			printf("%I64d\n",f[x]);
			continue;
		}

		for (i=1; i<=3; i++)
			for (j=1; j<=3; j++)
			{
				matrix[i][j]=0;
				if (i==j)
					z[i][j]=1;
				else
					z[i][j]=0;
			}

		matrix[2][1]=1;
		matrix[3][2]=1;
		matrix[2][3]=1;
		matrix[3][3]=1;
		x-=3;
		work(x);
		printf("%I64d\n",(z[1][3]+z[2][3]+2*z[3][3])%mod);
	}

	return 0;
}