program Project1;
const INF:longint=maxlongint>>1;
var
  i,j,n:longint;
  v,dist,q:array[0..10000]of longint;
  map:array[0..1005,0..1005]of longint;
  num:array[0..10000]of ansistring;
  flag:array[0..10000]of boolean;
procedure swap(var a,b:char);
var t:char;
  begin
    t:=a; a:=b; b:=t;
  end;
  
function check(s1,s2:ansistring):boolean;
var
  i,p:longint;
  p1,p2:longint;
  begin
    p:=0;
    for i:=1 to length(s1) do
     if s1[i]<>s2[i] then inc(p);
    if p>2 then exit(false);
    if p<=1 then exit(true);
    p1:=0; p2:=0;
    for i:=1 to length(s1) do
      if s1[i]<>s2[i] then if p1=0 then p1:=i else p2:=i;
    swap(s1[p1],s1[p2]);
    if s1=s2 then exit(true);
    exit(false);
  end;

function lcp(s1,s2:ansistring):longint;
var
  ans,i:longint;
  begin
    ans:=0;
    for i:=1 to length(s1) do
     if s1[i]=s2[i] then inc(ans) else break;
    exit(ans);
  end;

procedure init;
var
  t:longint;
  begin
    assign(input,'math.in'); reset(input);
    assign(output,'math.out'); rewrite(output);
    filldword(map,sizeof(map)>>2,INF);
    readln(n);
    for i:=0 to 9 do read(v[i]); readln;
    for i:=1 to n do readln(num[i]);
    for i:=1 to n-1 do
     for j:=i+1 to n do
       begin
         if i=j then continue;
         if check(num[i],num[j]) then
           begin
             t:=lcp(num[i],num[j]);
             map[i,j]:=v[t];
             map[j,i]:=v[t];
           end;
       end;
  end;
  
function relax(w,v:longint):boolean;
  begin
    if dist[w]>dist[v]+map[w,v] then
      begin
        dist[w]:=dist[v]+map[w,v];
        exit(true);
      end;
    exit(false);
  end;
  
procedure spfa(v:longint);
var
  h,r,i:longint;
  begin
    fillchar(flag,sizeof(flag),false);
    fillchar(q,sizeof(q),0);
    filldword(dist,sizeof(dist)>>2,INF);
    h:=0;
    r:=1;
    dist[v]:=0;
    flag[v]:=true;
    q[1]:=v;
    while h<>r do
      begin
        inc(h);
        flag[q[h]]:=false;
        for i:=1 to n do
         if relax(i,q[h]) then
          if not flag[i] then
            begin
              inc(r);
              q[r]:=i;
              flag[i]:=true;
            end;
      end;
  end;

procedure main;
  begin
    spfa(1);
    if dist[n]=INF then writeln(-1) else writeln(dist[n]);
    close(input); close(output);
  end;
begin
  init;
  main;
end.

