//gcd(F(m),F(n))=F(gcd(m,n))
#include <cstdio>
#include <cstring>
#include <algorithm>
#define MOD 19491001
using namespace std;

const long long a[2][2] = {{1, 1}, {1, 0}};
const long long b[2][2] = {{1, 0}, {0, 0}};
long long f[2][2], g[2][2], t[2][2];

int gcd(int x, int y);
void power(int p);

int main()
{
	freopen("Fibonacci.in", "r", stdin);
	freopen("Fibonacci.out", "w", stdout);
	
	int test;
	scanf("%d", &test);
	while (test--)
	{
		int x, y;
		scanf("%d%d", &x, &y);
		int p = gcd(x, y);
		memcpy(g, a, sizeof(a));
		memcpy(f, b, sizeof(b));
		power(p);
		printf("%I64d\n", f[0][0]);
	}
	
	return 0;
}

void power(int p)
{
	if (p == 1) return ;
	p--;
	while (p)
	{
		if (p & 1)
		{
			memcpy(t, f, sizeof(t));
			memset(f, 0, sizeof(f));
			for (int i = 0; i < 2; i++)
				for (int j = 0; j < 2; j++)
					for (int k = 0; k < 2; k++)
						f[i][j] = (f[i][j] + t[i][k] * g[k][j] % MOD) % MOD;
		}
		memcpy(t, g, sizeof(t));
		memset(g, 0, sizeof(g));
		for (int i = 0; i < 2; i++)
			for (int j = 0; j < 2; j++)
				for (int k = 0; k < 2; k++)
					g[i][j] = (g[i][j] + t[i][k] * t[k][j] % MOD) % MOD;
		p >>= 1;
	}
}

int gcd(int x, int y)
{
	if (x < y) swap(x, y);
	int r;
	while (y)
	{
		r = x % y;
		x = y;
		y = r;
	}
	return x;
}
