#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <algorithm>

using namespace std; 
const long long mod = 19491001;
long long store[3][3];
long long f[3][3]=
{
 {0,0},
 {0,1},
 {1,1}
};
long long ans[3]={0,1,1};
long long ff[3][3];

int gcd(int x,int y)
{
 if(x<y)
	 swap(x,y);
 if(y==0)
 return x;
 return gcd(y,x%y);
}
void solve(int x)
{
 int i,j,k;
 while(x)
	{
	if(x&1)
		{
		for(i=1;i<=2;i++)
			for(j=1;j<=2;j++)
				for(k=1;k<=2;k++)
				  ff[i][j]+=((f[i][k]%mod)*(store[k][j]%mod))%mod;
			for(i=1;i<=2;i++)
				for(j=1;j<=2;j++)			
				store[i][j]=ff[i][j],ff[i][j]=0;
		}
	for(i=1;i<=2;i++)
		for(j=1;j<=2;j++)
	        for(k=1;k<=2;k++)
		      ff[i][j]+=((f[i][k]%mod)*(f[k][j]%mod))%mod;
		for(i=1;i<=2;i++)
            for(j=1;j<=2;j++)			
		    f[i][j]=ff[i][j],ff[i][j]=0;
	x>>=1;	
	}
   ans[2]=(store[2][1]+store[1][1])%mod;
}

int main()
{   
	freopen("fibonacci.in","r",stdin);
	freopen("fibonacci.out","w",stdout);
	int n,i,j,k;
	scanf("%d",&n);
	
	while(n--)
		{
		int a,b;
		scanf("%d%d",&a,&b);
		int res=gcd(a,b);
		ans[1]=1,ans[2]=1;
		f[1][1]=0,f[1][2]=1,f[2][1]=1,f[2][2]=1;
		store[1][1]=0,store[1][2]=1,store[2][1]=1,store[2][2]=1;
		if(res==1 && res==2)
	    printf("1\n");
		else
		solve(res-2);
		printf("%I64d\n",ans[2]);
		}
	
	
	return 0;
}