#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <ctime>
#define P 30000 + 3
#define N 30000 + 3
#define oo 9999999.9
#define clear(a, b)	memset(a, b, sizeof a)

typedef long long ll;
typedef unsigned long long ull;
using namespace std;

const double qar = sqrt(5) * 0.5 - 0.5;

ull n;

struct st {
	ull x, y;
	double l;
}m, a1, a2;

inline double calc(st now) {
	return now.x * 1.0 / now.y;
}

inline ull gcd(ull a, ull b) {
	for (ull c; c = a; a = b % a, b = c);
	return b;
}

void out() {
	ull g = gcd(a1.x, a1.y);
	a1.x /= g;	a1.y /= g;
	g = gcd(a2.x, a2.y);
	a2.x /= g;	a2.y /= g;
	if (fabs(calc(a1) - qar) < fabs(calc(a2) - qar))
		printf("%I64u/%I64u\n", a1.x, a1.y);
	else	printf("%I64u/%I64u\n", a2.x, a2.y);
}

int main(){
	freopen("gold.in", "r", stdin);	freopen("gold.out", "w", stdout);
	scanf("%I64u", &n);
	m.x = m.y = n;
	a1.l = -oo;
	a2.l = oo;
	while (m.x > 0 && m.y > 0)
		if (m.l = calc(m), m.l > qar) {
			if (m.l < a2.l)
				a2 = m;
			m.x--;
		}
		else {
			if (m.l > a1.l && m.l != qar)
				a1 = m;
			m.y--;
		}
	out();
	fclose(stdin);	fclose(stdout);	return 0;
}
