#include<cstdio>
#include<cstdlib>
#include<cstring>
using namespace std;
const long long MOD=19950717;
struct Mat
{
    long long mat[3][3];
    void clear()
    {
        for(int i=0;i<=1;i++)
            for(int j=0;j<=1;j++)
                mat[i][j]=1;
        mat[1][1]=0;
    }
};
Mat operator * (Mat a,Mat b)
{
    Mat c;
    int i,j,k;
    memset(c.mat,0,sizeof(c.mat));
    for(i=0;i<=1;i++)
    {
        for(j=0;j<=1;j++)
            for(k=0;k<=1;k++)
            {
                if(!a.mat[i][k] || !b.mat[k][j]) 
                   continue;
                c.mat[i][j]+=a.mat[i][k]*b.mat[k][j];
                if(c.mat[i][j]>MOD) 
                   c.mat[i][j]%=MOD;
            }
    }
    return c;
}
Mat operator ^ (Mat a,long long k)
{
    Mat c;
    int i,j;
    for(i=0;i<=1;i++)
        for(j=0;j<=1;j++)
            c.mat[i][j]=(i==j);
    while(k)
    {
        if(k&1) 
           c=c*a;
        k>>=1;
        a=a*a;
    }
    return c;
}
long long gcd(long long n,long long m)
{
     long long r;
     r=n%m;
     while(r)
     {
        n=m;
        m=r;
        r=n%m;
     }
     return m;
}
int main()
{
    freopen("fibonacci.in","r",stdin);
    freopen("fibonacci.out","w",stdout);
    long long n,m;
    Mat a;
    int gay;
    scanf("%d",&gay);
    for(int i=1;i<=gay;i++)
    {
        scanf("%I64d%I64d",&n,&m);
        //if(n==0 && m==0)
        //   break;
        a.clear();
        long long x=gcd(n,m);
        a=(a^(x-1));
        printf("%I64d\n",a.mat[0][0]);
    }
    return 0;
}
