#include<cstdio>
#include<cstring>
#include<cmath>
#include<iostream>
#include<algorithm>
#define mod 19491001

using namespace std;

int n;

int a,b,c;

long long x[2][2],y[2][2]={{0,1},{1,1}},an[2][2];

int gcd(int i,int j)
{
	if(!j)
		return i;

	return gcd(j,i%j);
}

void ksm(int m)
{
	int i,j,k;

	if(m==1)
	{
		for(i=0;i<2;i++)
			for(j=0;j<2;j++)
				x[i][j]=y[i][j];
	
		return;
	}

	ksm(m/2);

	memset(an,0,sizeof(an));

	for(i=0;i<2;i++)
		for(j=0;j<2;j++)
		{
			for(k=0;k<2;k++)
				an[i][j]+=(x[i][k]*x[k][j])%mod;
		
			an[i][j]%=mod;
		}

	memset(x,0,sizeof(x));

	if(m&1)
	{
		for(i=0;i<2;i++)
			for(j=0;j<2;j++)
			{
				for(k=0;k<2;k++)
					x[i][j]+=(y[i][k]*an[k][j])%mod;
			
				x[i][j]%=mod;
			}
	}

	else
	{
		for(i=0;i<2;i++)
			for(j=0;j<2;j++)
				x[i][j]=an[i][j];
	}

	return;
}

int main()
{
	freopen("fibonacci.in","r",stdin);
	freopen("fibonacci.out","w",stdout);

	int i;

	scanf("%d",&n);

	for(i=1;i<=n;i++)
	{
		scanf("%d%d",&a,&b);
	
		c=gcd(a,b);
	/*/
		cout<<c<<endl;
	//*/
		ksm(c-1);
	
		printf("%I64d\n",(x[0][0]+x[0][1])%mod);
	}

	return 0;
}