#include <fstream>
#include <algorithm>
#include <numeric>
using namespace std;
ifstream fin ("Card.in");
ofstream fout("Card.out");
const int max_N = 2000006, max_M = max_N;
int N, M, T;
int x[max_N] = {0}, y[max_M] = {0};
inline int abs(int foo) {return(foo>0?foo:-foo);}
long long solve(int *d, int length)
{
    int s = accumulate(d, d+length, 0);
    if (s%length != 0) return(-1);
    s = s/length;
    int b[max_N] = {0};
    for (int i=0; i<length; ++i) b[i] = d[i] - s;
    for (int i=1; i<length; ++i) b[i] += b[i-1];
    sort(b, b+length);
    long long ans = 0, mid = b[length/2];
    for (int i=0; i<length; ++i) ans += abs(b[i] - mid);
    return(ans);
}
int main(void)
{
    ios::sync_with_stdio(false);
    fin >> N >> M >> T;
    for (int i=0; i<T; ++i)
    {
        int a, b;
        fin >> a >> b;
        x[a-1]++, y[b-1]++;
    }
    int code = 0;
    long long ans_x = solve(x, N), ans_y = solve(y, M);
    if (ans_x > 0) code += 1;
    if (ans_y > 0) code += 2;
    switch (code)
    {
        case 0:
            fout << "you are as stupid as lishu" << endl; break;
        case 1:
            fout << "hehe " << ans_x << endl; break;
        case 2:
            fout << "haha " << ans_y << endl; break;
        case 3:
            fout << "it is wonderful " << ans_x+ans_y << endl; break;
    }
    fin.close();
    fout.close();
    return(0);
}
