#include <stdio.h>
#include <stdlib.h>

#define Abs(x) ((x)>0?(x):-(x))
#define Min(a,b) ((a)<(b)?(a):(b))
#define Max(a,b) ((a)>(b)?(a):(b))
#define INF 1000000000
#define MOD 19491001
#ifdef WIN32
	char instr[20]="%I64d";
#else
	char instr[20]="%lld";
#endif

long long GCD(long long a,long long b)
{
	if(a%b==0)
		return b;
	return GCD(b,a%b);
}
long long k;
struct Matrix
{
	long long num[3][3];
	friend Matrix operator * (Matrix a,Matrix b)
	{
		Matrix ret;
		ret.num[1][1]=((a.num[1][1]*b.num[1][1])%MOD
				  +(a.num[2][1]*b.num[1][2])%MOD)%MOD;
		ret.num[1][2]=((a.num[1][1]*b.num[2][1])%MOD
				  +(a.num[2][1]*b.num[2][2])%MOD)%MOD;
		ret.num[2][1]=((a.num[1][2]*b.num[1][1])%MOD
				  +(a.num[2][2]*b.num[1][2])%MOD)%MOD;
		ret.num[2][2]=((a.num[1][2]*b.num[2][1])%MOD
				  +(a.num[2][2]*b.num[2][2])%MOD)%MOD;
		return ret;
	}
	Matrix()
	{
		num[1][1]=num[2][2]=1;
		num[1][2]=num[2][1]=0;
	}
}one;
Matrix Pow(Matrix x,long long a)
{
	if(a==0)	return one;
	if(a==1)	return x;
	Matrix t=Pow(x,a/2);
	t=t*t;
	if(a%2==1)
		t=t*x;
	return t;
}
int main()
{
	int i,j;
	freopen("Fibonacci.in","r",stdin);
	freopen("Fibonacci.out","w",stdout);
	int T;
	scanf("%d",&T);
	long long a,b;
	while(T--)
	{
		scanf(instr,&a);
		scanf(instr,&b);
		k=GCD(a,b);
		Matrix x;
		x.num[1][1]=1;
		x.num[1][2]=1;
		x.num[2][1]=1;
		x.num[2][2]=0;
		x=Pow(x,k);
		printf(instr,x.num[1][2]);
		printf("\n");
	}
	return 0;
}

