#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
const long long mod=19491001;
int T;
int a,b,n;
long long ans[3][3],f[3][3],h[3][3];

int gcd(int x,int y)
{
	if (x==0) return y;
	return gcd(y%x,x);	
}

void qpower(int b)
{
	for (;b>0;b>>=1) 
	{
		if (b&1) 
		{
			memset(h,0,sizeof h);
			for (int i=1;i<=2;i++) 
				for (int j=1;j<=2;j++) 
					for (int k=1;k<=2;k++) 
						h[i][j]=(h[i][j]+f[i][k]*ans[k][j])%mod;
			memcpy(ans,h,sizeof h);	
		}
		memset(h,0,sizeof h);
		for (int i=1;i<=2;i++) 
			for (int j=1;j<=2;j++) 
				for (int k=1;k<=2;k++) 
					h[i][j]=(h[i][j]+f[i][k]*f[k][j])%mod;
		memcpy(f,h,sizeof h);
	}
}

int main()
{
	freopen("fibonacci.in","r",stdin);
	freopen("fibonacci.out","w",stdout);
	scanf("%d",&T);
	while (T--) 
	{	
		f[1][2]=f[2][1]=f[2][2]=1;f[1][1]=0;
		ans[1][1]=ans[1][2]=0;ans[2][2]=ans[2][1]=1;
		scanf("%d%d",&a,&b);
		if (a>b) swap(a,b);
		n=gcd(a,b);
		qpower(n-1);
		printf("%I64d\n",ans[2][2]);
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}	
