#include<cstdio>
#include<cstring>
#include<algorithm>
#include<cmath>
using namespace std;
long long n;
double goal,cur=100;
int fz,fm;

int gcd(int x,int y)
{
	if (x==0) return y;
	return gcd(y%x,x);	
}

int main()
{
	freopen("gold.in","r",stdin);
	freopen("gold.out","w",stdout);
	goal=(sqrt(5)-1)/2;
	scanf("%I64d",&n);
	if (n==1)
	{
		printf("1\n");
		return 0;
	}
	for (int i=2;i<=n;i++) 
	{
		int l=1,r=i-1;
		while (l<=r) 
		{
			int mid=(l+r)>>1;
			double k=double(mid)/i;
			if (fabs(k-goal)<fabs(cur-goal)) 
			{
				cur=k;
				fz=mid;fm=i;	
			}
			if (k>goal) r=mid-1;
			else l=mid+1;
		}
	}
	int p=gcd(fz,fm);
	fz/=p;fm/=p;
	printf("%d/%d\n",fz,fm);
	fclose(stdin);
	fclose(stdout);
	return 0;	
}
