/*
PROG: C++
TASK: Math
*/

#include <ctime>
#include <cmath>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>
#include <queue>

using namespace std ;

FILE *fi , *fo ;

typedef pair < int , int > pii ;
priority_queue < pii , vector<pii> , greater<pii> > q ;

int N ;
int cost[15] ;
char num[10010][15] ;
int st[4000010] , en[4000010] , vl[4000010] , arc ;
int slas[10010] , spre[4000010] , elas[10010] , epre[4000010] ;

int dis[10010] ;
void spfa()
{
	int i , now , to ; pii tmp ;
	for ( i=2 ; i<=N ; i++ ) dis[i]=0x7FFFFFF ;
	q.push(make_pair(0,1)) ;
	while ( !q.empty() )
	{
		tmp=q.top() ; q.pop() ;
		now=tmp.second ;
		if ( dis[now]<tmp.first ) continue ;
		for ( i=slas[now] ; i ; i=spre[i] )
		{
			to=en[i] ;
			if ( dis[to]>dis[now]+vl[i] )
			{
				dis[to]=dis[now]+vl[i] ;
				q.push(make_pair(dis[to],to)) ;
			}
		}
		for ( i=elas[now] ; i ; i=epre[i] )
		{
			to=st[i] ;
			if ( dis[to]>dis[now]+vl[i] )
			{
				dis[to]=dis[now]+vl[i] ;
				q.push(make_pair(dis[to],to)) ;
			}
		}
	}
	return ;
}

int cmp ( int a , int b )
{
	int dif1=0 , dif2=0 , i ;
	for ( i=0 ; i<10 ; i++ )
		if ( num[a][i]!=num[b][i] )
		{
			if ( !dif1 ) dif1=i+1 ;
			else if ( !dif2 ) dif2=i+1 ;
			else return 0 ;
		}
	if ( !dif2 ) return dif1 ;
	else if ( num[a][dif1-1]==num[b][dif2-1]&&num[a][dif2-1]==num[b][dif1-1] ) return dif1 ;
	else return 0 ;
}

int main()
{
	fi = fopen ( "Math.in" , "r" ) ;
	fo = fopen ( "Math.out" , "w" ) ;
	
	int i , j , t ;
	fscanf ( fi , "%d" , &N ) ;
	for ( i=1 ; i<=10 ; i++ ) fscanf ( fi , "%d%*c" , &cost[i] ) ;
	for ( i=1 ; i<=N ; i++ )
	{
		fscanf ( fi , "%s" , num[i] ) ;
		for ( j=1 ; j<i ; j++ )
			if ( t=cmp(j,i) )
			{
				arc++ ;
				st[arc]=j , en[arc]=i , vl[arc]=cost[t] ;
				spre[arc]=slas[st[arc]] , slas[st[arc]]=arc ;
				epre[arc]=elas[en[arc]] , elas[en[arc]]=arc ;
			}
	}
	spfa() ;
	fprintf ( fo , "%d\n" , dis[N] ) ;
	
	fclose ( fi ) ;
	fclose ( fo ) ;
	return 0 ;
}
