#include <stdio.h>
#include <stdlib.h>
#define mod 10000007

int hash[mod];
long long value[12],a[10003],dis[10003],vis[10003];
long long last[10003],pre[2000003],en[2000003],len[2000003],sum;
long long ten[12]={1,10,100,1000,10000,100000,1000000,10000000LL,100000000LL,1000000000LL,10000000000LL,100000000000LL};
long long n,i,j,k,x,y,z,zz,top;
struct str
{
	long long x,dis;
}heap[2000003];

long long getbit(long long a,long long b)
{
	return a/ten[10-b]%10;
}

long long replace(long long x,long long b,long long t)
{
	return x-getbit(x,b)*ten[10-b]+t*ten[10-b];
}

void build(long long x,long long y,long long z)
{
	sum++;
	en[sum]=y;
	pre[sum]=last[x];
	last[x]=sum;
	len[sum]=z;
//	printf("%I64d %I64d     %I64d\n",x,y,z);
}

long long gethash(long long k)
{
	long long i;

	i=k%mod;
	while (hash[i]!=0 && a[hash[i]]!=k)
		i=(i+1)%mod;

	return i;
}

void in(long long x,long long d)
{
	long long i,j;

	top++;
	i=top;
	j=i>>1;
	while (j>0 && d<heap[j].dis)
	{
		heap[i]=heap[j];
		i=j;
		j>>=1;
	}

	heap[i].x=x;
	heap[i].dis=d;
}

void out(void)
{
	long long i,j;
	struct str t;

	t=heap[top];
	top--;
	i=1;
	j=2;
	while (j<=top)
	{
		if (j+1<=top && heap[j+1].dis<=heap[j].dis)
			j++;

		if (heap[j].dis<t.dis)
		{
			heap[i]=heap[j];
			i=j;
			j<<=1;
		}
		else
			j=top+1;
	}

	heap[i]=t;
}

int main()
{
	freopen("Math.in","r",stdin);
	freopen("Math.out","w",stdout);
	scanf("%I64d",&n);
	for (i=0; i<10; i++)
		scanf("%I64d",&value[i]);

	for (i=1; i<=n; i++)
	{
		scanf("%I64d",&a[i]);
		dis[i]=100000000;
		x=gethash(a[i]);
		if (hash[x]!=0)
			continue;

		hash[x]=i;
		for (j=1; j<=10; j++)
		{
			y=getbit(a[i],j);
			for (k=0; k<10; k++)
			{
				if (y==k)
					continue;

				z=replace(a[i],j,k);
				x=gethash(z);
				if (hash[x]!=0)
				{
					build(hash[x],i,value[j-1]);
					build(i,hash[x],value[j-1]);
				}
			}
		}

		for (j=1; j<10; j++)
			for (k=j+1; k<=10; k++)
			{
				y=getbit(a[i],j);
				z=getbit(a[i],k);
				if (y==z)
					continue;

				zz=replace(a[i],j,z);
				zz=replace(zz,k,y);
			//	printf("%I64d  %I64d\n",a[i],zz);
				x=gethash(zz);
				if (hash[x]!=0)
				{
					build(i,hash[x],value[j-1]);%ll
					build(hash[x],i,value[j-1]);
				}
			}
	}

	top=0;
	in(1,0);
	while (vis[n]!=1003 && top>0)
	{
		while (top>0 && vis[heap[1].x]==1003)
			out();

		if (top==0)
			break;

		x=heap[1].x;
		y=heap[1].dis;
		out();
		vis[x]=1003;
		dis[x]=y;
		for (i=last[x]; i!=0; i=pre[i])
			if (dis[en[i]]>dis[x]+len[i])
			{
				dis[en[i]]=dis[x]+len[i];
				in(en[i],dis[en[i]]);
			}
	}

	if (vis[n]!=1003)
		printf("-1\n");
	else
		printf("%I64d\n",dis[n]);

	return 0;
}