#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<algorithm>
using namespace std;

const int Mod=19491001;

int gcd(int a,int b)
{
	if(!b)return a;
	return gcd(b,a%b);
}

struct Matrix
{
	int g[2][2];
	Matrix()
	{
		memset(g,0,sizeof g);
	}
	friend Matrix operator * (const Matrix& a,const Matrix& b)
	{
		Matrix c;
		int i,j,k;
		for(i=0;i<2;++i)
			for(j=0;j<2;++j)
				for(k=0;k<2;++k)
					c.g[i][j]=(long long)(c.g[i][j]+(long long)a.g[i][k]*b.g[k][j])%Mod;
		return c;
	}
	void print()
	{
		int i,j;
		for(i=0;i<2;++i,printf("\n"))
			for(j=0;j<2;++j)
				printf("%d ",g[i][j]);
		printf("\n");
	}
};

/*
	n-1 0 1   n-2
	n	1 1   n-1
   */

int get(int u)
{
	Matrix c,k;
	c.g[0][0]=0;c.g[0][1]=1;
	c.g[1][0]=1;c.g[1][1]=1;
	k.g[0][0]=k.g[1][1]=1;
	while(u)
	{
		if(u%2==1)k=k*c;
		c=c*c;
		u=u/2;
	}
	return k.g[0][1];
}

int main()
{
	freopen("Fibonacci.in","r",stdin);freopen("Fibonacci.out","w",stdout);
	int n,a,b;
	scanf("%d",&n);
	while(n--)
	{
		scanf("%d %d",&a,&b);
		printf("%d\n",get(gcd(a,b)));
	}
	return 0;
}
