#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<algorithm>
#include<queue>
#include<iostream>
using namespace std;

const int MAX=10000+10;
const int MAXE=2000000;
typedef long long LL;

int n,val[MAX],num[MAX];
LL number[MAX],come[MAX];
LL pow[]={1LL,10LL,100LL,1000LL,10000LL,100000LL,1000000LL,10000000LL,100000000LL,1000000000LL,10000000000LL};

int cmp(int a,int b)
{
	return number[a]<number[b];
}

int find(LL a)
{
	int left=1,right=n;
	while(left<right)
	{
		int mid=(left+right+1)/2;
		if(number[num[mid]]<=a)left=mid;
		else right=mid-1;
	}
	if(number[num[left]]==a)return num[left];
	else return 0;
}

int lcp(LL a,LL b)
{
	int i;
	for(i=0;i<10;++i)
		if(a/pow[i]==b/pow[i])return 10-i;
	return 0;
}

LL revise(LL p,int i,int a)
{
	p-=p/pow[i-1]%10*pow[i-1];
	p+=a*pow[i-1];
	return p;
}

LL swap(LL p,int i,int j)
{
	int a=p/pow[i-1]%10,b=p/pow[j-1]%10;
	p+=(b-a)*pow[i-1];
	p+=(a-b)*pow[j-1];
	return p;
}

int begin[MAX],next[MAXE],t[MAXE],V[MAXE],tot;

void add(int a,int b)
{
	t[++tot]=b;
	next[tot]=begin[a];
	begin[a]=tot;
	V[tot]=val[lcp(number[a],number[b])];
}

queue<int> q;
int dist[MAX],hash[MAX];

int main()
{
	freopen("Math.in","r",stdin);freopen("Math.out","w",stdout);
	int i,j,k,temp,u,v;
	scanf("%d",&n);
	for(i=0;i<10;++i)scanf("%d",&val[i]);
	for(i=1;i<=n;++i)
	{
		scanf("%I64d",&number[i]);
		num[i]=i;
	}
	sort(num+1,num+n+1,cmp);
	for(i=1;i<=n;++i)
	{
		for(j=1;j<=10;++j)
			for(k=0;k<10;++k)
				if((temp=find(revise(number[i],j,k))))
				{
					if(temp==i)continue;
					add(i,temp);
				}
		for(j=1;j<=10;++j)
			for(k=j+1;k<=10;++k)
				if((temp=find(swap(number[i],j,k))))
				{
					if(temp==i)continue;
					add(i,temp);
				}
	}
	for(i=1;i<=n;++i)
		dist[i]=-1;
	q.push(1);dist[1]=0;
	while(!q.empty())
	{
		u=q.front();q.pop();hash[u]=0;
		for(i=begin[u];i;i=next[i])
		{
			v=t[i];
			if(dist[v]==-1 || dist[v]>dist[u]+V[i])
			{
				dist[v]=dist[u]+V[i];
				come[v]=u;
				if(!hash[v])
				{
					hash[v]=1;
					q.push(v);
				}
			}
		}
	}
	/*
	int now=v;
	while(now)
	{
		cout<<number[now]<<" "<<now<<endl;
		now=come[now];
	}
	*/
	printf("%d\n",dist[n]);
	return 0;
}
