#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>

using namespace std;

const int MD = 19491001;

int T;
int n, m, x;

typedef long long matrix[2][2];
matrix ans, now, tmp;

void time(matrix a, matrix b) {
	memset(tmp, 0, sizeof tmp);	
	for (int i = 0; i < 2; ++i)
		for (int j = 0; j < 2; ++j)
			for (int k = 0; k < 2; ++k)
				if (tmp[i][j] += a[i][k] * b[k][j] % MD, tmp[i][j] >= MD)
					tmp[i][j] -= MD;
	for (int i = 0; i < 2; ++i)		
		for (int j = 0; j < 2; ++j)
			a[i][j] = tmp[i][j];
}

int gcd(int a, int b) {
	for (int c; c = a; a = b % a, b = c);
	return b;
}

void work() {
	memset(ans, 0, sizeof ans);
	memset(now, 0, sizeof now);
	ans[0][0] = ans[1][1] = now[0][1] = now[1][0] = now[1][1] = 1;
	scanf("%d%d", &n, &m);
	x = gcd(n, m);
	for (; x; x >>= 1) {
		if (x & 1)
			time(ans, now);
		time(now, now);
	}
	printf("%I64d\n", ans[0][1] % MD);
}

int main() {
	freopen("Fibonacci.in", "r", stdin);	freopen("Fibonacci.out", "w", stdout);
	for (scanf("%d", &T); T--;)
		work();
	fclose(stdin);	fclose(stdout);	return 0;
}
//gcd(F[a], F[b]) = F[gcd(a, b)]
