#include<iostream>
#include<fstream>
#include<algorithm>

using namespace std;
const int MOD=19491001;
ifstream fin("Fibonacci.in");
ofstream fout("Fibonacci.out");

long long a[10],b[10];

void mul(int x)
{
	b[0]=(a[0]*a[0]%MOD+a[1]*a[2]%MOD)%MOD;
	b[1]=(a[0]*a[1]%MOD+a[1]*a[3]%MOD)%MOD;
	b[2]=(a[2]*a[0]%MOD+a[2]*a[3]%MOD)%MOD;
	b[3]=(a[2]*a[1]%MOD+a[3]*a[3]%MOD)%MOD;
	for(int i=0;i<4;++i)a[i]=b[i];
	if(x)
	{
		b[0]=a[1]%MOD;
		b[1]=(a[0]+a[1])%MOD;
		b[2]=a[3]%MOD;
		b[3]=(a[2]+a[3])%MOD;
		for(int i=0;i<4;++i)a[i]=b[i];
	}
}

long long fibonacci(int x)
{
	if(x==1)
		return 1;
	fibonacci(x>>1);
	if(x&1)
		mul(1);
	else
		mul(0);
	return a[1];
}

int main()
{
	int T;
	fin>>T;
	for(;T--;)
	{
		int p,q,r;
		fin>>p>>q;
		if(p<q)swap(p,q);
		while(q>0)
		{
			r=p%q;
			p=q;
			q=r;
		}

		b[0]=b[1]=b[2]=b[3]=a[0]=0;
		a[1]=a[2]=a[3]=1;
		fout<<fibonacci(p)<<endl;
	}
	return 0;
}
