#include<stdio.h>
#include<iostream>

using std::cout;
using std::endl;

const long long MOD=19491001;

int gcd(int a,int b)
{
	int t;
	if(a>b)
		t=a,a=b,b=t;
	for(;a;)
		t=a,a=b%a,b=t;
	return b;
}

struct matrix
{
	long long a[2][2];
	matrix(long a00,long long a01,long long a10,long long a11)
	{
		a[0][0]=a00,a[0][1]=a01;
		a[1][0]=a10,a[1][1]=a11;
	}
};

matrix operator * (const matrix &l,const matrix &r)
{
	int i,j,k;
	matrix ans(0,0,0,0);
	for(i=0;i<2;++i)
		for(j=0;j<2;++j)
			for(k=0;k<2;++k)
				ans.a[i][j]=(ans.a[i][j]+l.a[i][k]*r.a[k][j])%MOD;
	return ans;
}

long long pow(int n)
{
	matrix a(1,1,1,0),ans(1,0,0,1);
	for(;n;n>>=1)
	{
		if(n&1)
			ans=ans*a;
		a=a*a;
	}
	return ans.a[1][0];
}

int main()
{
	freopen("fibonacci.in","r",stdin);
	freopen("fibonacci.out","w",stdout);
	int n,a,b;
	for(scanf("%d",&n);n--;)
	{
		scanf("%d%d",&a,&b);
		cout << pow(gcd(a,b))%MOD << endl;
	}
	return 0;
}
