#include <cstdio>
#include <cstdlib>
using namespace std;

const long long mod = 19491001;
typedef long long ll;
ll a[5][5], mid[5][5], c[5][5];

ll gcd(ll x, ll y){
    for (ll z=x%y; z!=0; x=y,y=z,z=x%y);
    return y;
}

ll cal(ll x){
    if (x==1 || x==2) return 1;
    int i, j, k;
    ll ans;
    x -= 2;
    mid[1][1] = mid[1][2] = mid[2][1] = 1;
    mid[2][2] = 0;
    a[1][1] = a[2][2] = 1; a[1][2] = a[2][1] = 0;
    c[1][1] = c[1][2] = c[2][1] = c[2][2] = 0;
    while (x>0){
        if (x&1){
            for (i=1; i<=2; i++)
                for (j=1; j<=2; j++)
                    for (k=1; k<=2; k++){
                        c[i][j] += a[i][k] * mid[k][j];
                        c[i][j] %= mod;
                    }
            for (i=1; i<=2; i++)
                for (j=1; j<=2; j++)
                    a[i][j] = c[i][j], c[i][j] = 0;
        }
        for (i=1; i<=2; i++)
            for (j=1; j<=2; j++)
                for (k=1; k<=2; k++){
                    c[i][j] += mid[i][k] * mid[k][j];
                    c[i][j] %= mod;
                }
        for (i=1; i<=2; i++)
            for (j=1; j<=2; j++)
                mid[i][j] = c[i][j], c[i][j] = 0;
        x>>=1;
    }
    ans = (a[1][1] + a[2][1])%mod;
    return ans;
}

int main(){
    int i, j, n;
    ll a, b, c;
    freopen("Fibonacci.in", "r", stdin);
    freopen("Fibonacci.out", "w", stdout);
    scanf("%d", &n);
        //printf("*");
    for (i=1; i<=n; i++){
        scanf("%I64d%I64d", &a, &b);
        c = gcd(a, b);
        //printf("%I64d\n", c);
        printf("%I64d\n", cal(c));
    }
    fclose(stdin);
    fclose(stdout);
    return 0;
}
