#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
#define Abs(x) ((x)>0?(x):-(x))
#define Min(a,b) ((a)<(b)?(a):(b))
#define Max(a,b) ((a)>(b)?(a):(b))
#define INF 1000000000
#define MAX_N 10010
#define MAX_M 1000100

int value[20];
int n,st,ed;
struct Line
{
	int t,next;
	int len;
	void Print()
	{
		printf("t:%3d next:%3d len:%3d\n",t,next,len);
	}
}lines[MAX_M];
struct Node
{
	long long num;
	int no;
}man[MAX_N];
int begin[MAX_N];
int lines_num;
long long pow10[11];
bool Cmp(Node a,Node b)
{
	return a.num<b.num;
}
int TwoFind(long long x)
{
	int l=1,r=n;
	int mid=(l+r)/2;
	while(l<=r)
	{
		mid=(l+r)/2;
		if(man[mid].num==x)
			return mid;
		if(man[mid].num<x)
			l=mid+1;
		else
			r=mid-1;
	}
	return -1;
}
void AddLine(int s,int t,int len)
{
	lines[++lines_num].t=t;
	lines[lines_num].next=begin[s];
	lines[lines_num].len=len;
	begin[s]=lines_num;
}
int LCP(long long a,long long b)
{
	int ret,i;
	for(ret=0,i=9;a/pow10[i]==b/pow10[i];ret++,i--)
		if(i-1<0)
			break;
	return ret;
}
void InitLine(int x)
{
	long long numx=man[x].num;
	int sw[12],i,j;
	long long t=numx;
	for(i=0;i<=9;i++)
	{
		sw[i]=t%10;
		t/=10;
	}
	t=numx;
	int ret;
	for(i=0;i<10;i++)
	{
		for(j=0;j<10;j++)
		if(j!=sw[i])
		{
			t=numx;
			t=t-pow10[i]*sw[i]+pow10[i]*j;
			ret=TwoFind(t);
			if(ret!=-1)
				AddLine(x,ret,value[LCP(numx,man[ret].num)]);
		}
	}
	for(i=0;i<10;i++)
		for(j=i+1;j<10;j++)
		if(sw[i]!=sw[j])
		{
			t=numx;
			t=t-pow10[i]*sw[i]+pow10[i]*sw[j];
			t=t-pow10[j]*sw[j]+pow10[j]*sw[i];
			ret=TwoFind(t);
			if(ret!=-1)
				AddLine(x,ret,value[LCP(numx,man[ret].num)]);
		}
}
int dist[MAX_N];
int queue[MAX_M];
bool v[MAX_N];
void SPFA()
{
	int i;
	for(i=1;i<=n;i++)	dist[i]=INF;
	dist[st]=0;
	queue[1]=st;
	v[st]=1;
	int head=1,tail=1,p,h;
	Line l;
	while(head<=tail)
	{
		h=queue[head++];
		v[h]=0;
		for(p=begin[h];p!=0;p=lines[p].next)
		{
			l=lines[p];
			if(dist[l.t]>dist[h]+l.len)
			{
				dist[l.t]=dist[h]+l.len;
				if(v[l.t]==0)
				{
					v[l.t]=0;
					queue[++tail]=l.t;
				}
			}
		}
	}
}

int main()
{
	int i,j;
	freopen("Math.in","r",stdin);
	freopen("Math.out","w",stdout);
	pow10[0]=1;for(i=1;i<=10;i++)pow10[i]=pow10[i-1]*10;
	scanf("%d",&n);
	for(i=0;i<=9;i++)
		scanf("%d",&value[i]);
	for(i=1;i<=n;i++)
	{
		#ifdef WIN32
			scanf("%I64d",&man[i].num);
		#else
			scanf("%lld",&man[i].num);
		#endif
		man[i].no=i;
	}
	std::sort(man+1,man+1+n,Cmp);
//	for(i=1;i<=n;i++)	printf("%lld %d\n",man[i].num,man[i].no);
	for(i=1;i<=n;i++)
	{
		if(1==man[i].no) st=i;
		if(n==man[i].no) ed=i;
	}
	for(i=1;i<=n;i++)
		InitLine(i);
//	for(i=1;i<=lines_num;i++)lines[i].Print();
	SPFA();
	if(dist[ed]==INF)
		printf("-1\n");
	else
		printf("%d\n",dist[n]);
	return 0;
}

